@warnings
@name Make Hair

main{
	
    selmode(USER);
    plynfo = polycount();
    plycnt = plynfo[1];

    below = .002;
    above = .003;
	onsurf = false;
	usesurf = false;
	surfnm = "";
	
	below = recall("smp_MKHR_below",.002);
	above = recall("smp_MKHR_above",.003);
	onsurf = recall("smp_MKHR_onsurf",false);
	usesurf = recall("smp_MKHR_usesurf",false);
	surfnm = recall("smp_MKHR_surfnm","Default");

    reqbegin("Make Stubble 1.1");
    reqsize(256,192);

    c1 = ctldistance("Depth of Root",below);
    ctlposition(c1,31,8);

    c2 = ctldistance("Height of Stubble",above);
    ctlposition(c2,31,31);
	
	c3 = ctlcheckbox("Make Point on Surface",onsurf);
    ctlposition(c3,62,58,146,18);

    c4 = ctlcheckbox("Assign Surface",usesurf);
    ctlposition(c4,62,80,146,18);

    c5 = ctlstring("Surface Name",surfnm);
    ctlposition(c5,43,106,165,20);
	ctlactive(c4,"dummyudf",c5);
	
    return if !reqpost();

    below = getvalue(c1);
    above = getvalue(c2);
	onsurf = getvalue(c3);
    usesurf = getvalue(c4);
    surfnm = getvalue(c5);

    reqend();

    OFS_IN = <below, below, below>;    
    OFS_EX = <above, above, above>;

	undogroupbegin();
    editbegin();
        for (j=1; j<=plycnt; j++){
            vecs = <0,0,0>;
            pntc = polypointcount(polygons[j]);
            pnts[pntc+1] = 0;
            pnts = polyinfo(polygons[j]);
            for (i=1; i<=pntc; i++){
                vecs += pointinfo(pnts[i+1]);
            }
            pnorm = polynormal(polygons[j]);
            base = <(vecs.x/pntc),(vecs.y/pntc),(vecs.z/pntc)>;
            pntA = nil;
            pntA += addpoint(base - (OFS_IN * pnorm));
			if (onsurf) pntA += addpoint(base);
            pntA += addpoint(base + (OFS_EX * pnorm));
            cpnt += pntA[2 + onsurf];
			if(!usesurf){
				ccrv += addcurve(pntA);
			} else {
				ccrv += addcurve(pntA,surfnm);
			}
        }
    editend();
	selhide(SELECTED);
    selpolygon(CLEAR);
	selpoint(CLEAR);
    selpolygon(SET,POLYID,ccrv);
    selpoint(SET,POINTID,cpnt);
	undogroupend();
	
	store("smp_MKHR_below",below);
	store("smp_MKHR_above",above);
	store("smp_MKHR_onsurf",onsurf);
	store("smp_MKHR_usesurf",usesurf);
	store("smp_MKHR_surfnm",surfnm);

}

dummyudf : value { return(value); }