@warnings
@name XTrim Spline

main{
    //debug();
    selmode(DIRECT);
    pcnt = pointcount();
    if(pcnt == 0) error("Need some points selected here!");
    editbegin();
        //Main Code Block Goes Here
        upnts = points;
        for(i=1;i<=pcnt; i++)
        {
            if(points[i].polygon == 1){
                tmp = points[i].polygon();
                if (tmp[1].isCurve() == 1)
                {
                    ncrv = nil;
                    rpnt = nil;
                    rcnt = 0;
                    pid = tmp[1];
                    cnt = pid.pointCount;
                    flg = 0;
                    for(j=1;j<=cnt;j++)
                    {
                        tpnt = pid.points[j];
                        if(!flg){
                            ncrv += tpnt;
                        } else {
                            rpnt += tpnt;
                            rcnt += 1;
                        }
                        if (tpnt == points[i]) flg = 1;
                    }
                    srf = pid.surface;
                    sta = 0;
                    if (pid.hasCCStart()) sta = 1;
                    if (pid.hasCCEnd()) sta = 2;                
                    rempoly(pid);
                    if (sta == 0) addcurve(ncrv,srf);
                    if (sta == 1) addcurve(ncrv,srf,START);
                    if (sta == 2) addcurve(ncrv,srf,END);
                    if (rcnt != 0) for(j=1;j<=rcnt;j++)rempoint(rpnt[j]);
                }
            }
        }
    editend();
    selpoint(CLEAR, POINTID, upnts);
}
